var keyboardControls = keyboardControls || {};

keyboardControls.checkKeysPressed = function( keyboard ){

	// if the 'f' key is pressed, increase the size of the renderElement to the maximum size
	// allowed by the holding container.
	
	//console.log( keyboard );

	if( keyboard["70"] ){

		var endTime = +new Date();

		if( ( endTime - keyboard.timeStamp ) > 250 ){

			if( camera.renderSizeToggle ){
				document.body.style.margin = "8px 8px 8px 8px";
				renderer.setSize( 1024, 768 );
				camera.aspect = 1024 / 768;
				camera.updateProjectionMatrix();
				camera.renderSizeToggle = false;

				// prevent the event from firing too fast again.
				keyboard.timeStamp = endTime;


			} else {
				document.body.style.margin = "0px 0px 0px 0px";
				renderer.setSize( window.innerWidth, window.innerHeight );
				camera.aspect = window.innerWidth / window.innerHeight;
				camera.updateProjectionMatrix();
				camera.renderSizeToggle = true;

				// prevent the event from firing too fast again.
				keyboard.timeStamp = endTime;
			}
		}
	}

	// if the 't' key is pressed, we'll allow the user to place towers
	if( keyboard["84"] && !userTaskManager.createWalls ){

		var endTime = +new Date();

		if( ( endTime - keyboard.timeStamp ) > 250 ){

			// If the user presses the same button twice we will cancel the user selection
			if( userTaskManager.createTowers ){

				// reset colors of all previous lines that were selected
				for( var i=0, ii=cells.previousSelection.length; i<ii; i++ ){
					grid.geometry.colors[ cells.previousSelection[i] ].setRGB( 0.3 , 0.3 , 0.3 );
				}

				grid.geometry.colorsNeedUpdate = true;
				// reset previous selection of lines.
				cells.previousSelection = [];

				// we're going to remove the following listeners as they're no longer needed.
				document.removeEventListener( 'mousemove' , mouseControls.checkMouseMoveForTowerPlacement , false );
				//document.removeEventListener( 'mousedown' , mouseControls.checkMouseDownForTowerPlacement , false );

				userTaskManager.createTowers = false;
				

			} else {

				// we're going to add the following listeners to the page as they're needed.
				document.addEventListener( 'mousemove' , mouseControls.checkMouseMoveForTowerPlacement , false );
				//document.addEventListener( 'mousedown' , mouseControls.checkMouseDownForTowerPlacement , false );

				userTaskManager.createTowers = true;

			} 

			// prevent the event from firing too fast again.
			keyboard.timeStamp = endTime;
		}
	}

	// if the 'w' key is pressed, we'll allow the user to place walls
	// left click to make new wall
	// right click to remove wall

	if( keyboard["87"] && !userTaskManager.createTowers ){

		var endTime = +new Date();

		if( ( endTime - keyboard.timeStamp ) > 250 ){

			// If the user presses the same button twice we will cancel the user selection
			if( userTaskManager.createWalls ){

				// reset colors of all previous lines that were selected
				for( var i=0, ii=cells.previousSelection.length; i<ii; i++ ){
					grid.geometry.colors[ cells.previousSelection[i] ].setRGB( 0.3 , 0.3 , 0.3 );
				}

				grid.geometry.colorsNeedUpdate = true;
				// reset previous selection of lines.
				cells.previousSelection = [];

				// we're going to remove the following listeners as they're no longer needed.
				document.removeEventListener( 'mousemove' , mouseControls.checkMouseMoveForWallPlacement , false );
				document.removeEventListener( 'mousedown' , mouseControls.checkMouseDownForWallPlacement , false );

				userTaskManager.createWalls = false;
				

			} else {

				// we're going to add the following listeners to the page as they're needed.
				document.addEventListener( 'mousemove' , mouseControls.checkMouseMoveForWallPlacement , false );
				document.addEventListener( 'mousedown' , mouseControls.checkMouseDownForWallPlacement , false );

				userTaskManager.createWalls = true;

			} 

			// prevent the event from firing too fast again.
			keyboard.timeStamp = endTime;

		}
	}
	
}

